﻿using System;
using System.Collections.ObjectModel;

namespace XGrid
{
    public class DataSource : ObservableCollection<Data>
    {
        #region Constructor

        public DataSource()
        {
        }

        public DataSource(int loadSize)
        {
            this.LoadData(loadSize, 1);
        }

        public DataSource(int loadSize, int depth)
        {
            this.LoadData(loadSize, depth);
        }

        #endregion // Constructor

        #region LoadData

        public void LoadData(int loadSize, int depth)
        {
            for (int i = 0; i < loadSize; i++)
            {
                int intData = i;
                bool boolData = i % 2 == 0;
                double doubleData = i * 1.5;
                DateTime dateTimeData = new DateTime(2009, 5, i / 24 + 1, i % 24, 0, 0);
                string stringData = string.Format("String {0}", i);
                DataSource dataItems = null;

                if (i % 2 == 0 && depth > 0)
                {
                    dataItems = new DataSource(4, depth - 1);
                }

                this.Add(new Data
                {
                    Int = intData,
                    Double = doubleData,
                    Bool = boolData,
                    String = stringData,
                    DateTime = dateTimeData,
                    DataItems = dataItems
                });
            }
        }

        #endregion // LoadData
    }
}
