﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Windows.Data;
using Infragistics.Controls.Grids.Primitives;
using Infragistics.Controls.Grids;
using System.Text;

namespace XGrid
{
    public class RowNumberingConverter : IValueConverter
    {
        private void ConstructText(RowBase row, StringBuilder sb)
        {
            if (row == null)
            {
                return;
            }

            if (row is ChildBand)
            {
                ConstructText(((ChildBand)row).ParentRow, sb);
            }
            else
            {
                Row r = row as Row;

                if (r != null)
                {
                    ConstructText(r.ParentRow, sb);
                }

                sb.AppendFormat("{0}.", row.Index + 1);
            }
        }

        public object Convert(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            CellBase resolvedValue = value as CellBase;

            if (value != null)
            {
                StringBuilder sb = new StringBuilder();

                ConstructText(resolvedValue.Row, sb);

                return sb.ToString();
            }

            return value;
        }

        public object ConvertBack(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            return DependencyProperty.UnsetValue;
        }
    }
}
